/*
 *  winxp_HandMotionInternals.h
 *  FingerWorks HID Hand Motion SDK (Windows-specific definitions)
 *
 *  Created by Wayne Westerman on Wed Jun 25 2003.
 *  Last Updated by Wayne Westerman on Wed Nov 19 2003.
 *  Copyright (c) 2003 FingerWorks, Inc. All rights reserved.
 **/
/* ***** BEGIN LICENSE BLOCK *****
* Version: MPL 1.1/GPL 2.0/LGPL 2.1
*
* The contents of this file are subject to the Mozilla Public License Version
* 1.1 (the "License"); you may not use this file except in compliance with
* the License. You may obtain a copy of the License at
* http://www.mozilla.org/MPL/
*
* Software distributed under the License is distributed on an "AS IS" basis,
* WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
* for the specific language governing rights and limitations under the
* License.
*
* The Original Code is win32_HandMotionInternals.h,
*   FingerWorks HID Hand Motion SDK (Windows-specific definitions).
*
* The Initial Developer of the Original Code is
* Wayne Westerman, FingerWorks, Inc.
*
* Portions created by the Initial Developer are Copyright (C) 2003
* by FingerWorks, Inc. All Rights Reserved.
*
* Contributor(s):
*
* Alternatively, the contents of this file may be used under the terms of
* either the GNU General Public License Version 2 or later (the "GPL"), or
* the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
* in which case the provisions of the GPL or the LGPL are applicable instead
* of those above. If you wish to allow use of your version of this file only
* under the terms of either the GPL or the LGPL, and not to allow others to
* use your version of this file under the terms of the MPL, indicate your
* decision by deleting the provisions above and replace them with the notice
* and other provisions required by the GPL or the LGPL. If you do not delete
* the provisions above, a recipient may use your version of this file under
* the terms of any one of the MPL, the GPL or the LGPL.
*
* ***** END LICENSE BLOCK ***** */


 #if !defined(_WIN32_WINNT) 
// Indicate this as a Windows XP app to pull in RawInput from Windows.h
#define _WIN32_WINNT 0x0501   
 #endif

#include <Windows.h>
#include "fwhid_HandMotionInternals.h"

#ifndef _winxp_HandMotionInternals_h_
#define _winxp_HandMotionInternals_h_


#ifdef __cplusplus
extern "C" {
#endif

#define kFWHID_BELKIN_USB_VENDOR_ID 0x50d
#define kFWHID_BELKIN_NOSTRAMO_USB_PRODUCT_ID 0x803
#define kFWHID_GRAVIS_USB_VENDOR_ID 0x47d
#define kFWHID_GRAVIS_ELIMINATOR_USB_PRODUCT_ID 0x4005
#define kFWHID_CHOEM_USB_VENDOR_ID 0x68E
#define kFWHID_CHOEM_JOYSTICKBOX_USB_PRODUCT_ID 0x00C6

//more Windows-specific structures here?

typedef struct {
	unsigned base_buttons;
	unsigned extra_buttons;
	unsigned directional_pad;
	unsigned joy1x;
	unsigned joy1y;
	unsigned joy2x;
	unsigned joy2y;
	unsigned joy1twist;
	unsigned joy2twist;
} FWHID_GamepadEvent, *FWHID_GamepadEventPtr;

typedef void (*FWHIDGamepadEventCALLBACK)(FWHID_GamepadEventPtr pFWGamepadEvent);

void FWHID_setGamepadEventCallback(FWHIDGamepadEventCALLBACK fwcallback);

typedef void (*FWHIDJoystickEventCALLBACK)(FWHID_GamepadEventPtr pFWGamepadEvent);

void FWHID_setJoystickEventCallback(FWHIDJoystickEventCALLBACK fwcallback);

LRESULT CALLBACK FWHID_WndProc (HWND hwnd, UINT nMsg, WPARAM wParam, LPARAM lParam);

#ifdef __cplusplus
}
#endif

#endif // _winxp_HandMotionInternals_h_

